/**
 * POCDMT000040Patient.java
 *
 * File generated from the cdaepsos3::POCDMT000040Patient uml Class
 * Generated by IHE - europe, gazelle team
 */
package net.ihe.gazelle.cdaepsos3;

import net.ihe.gazelle.gen.common.ConstraintValidatorModule;
import org.w3c.dom.Document;
import org.w3c.dom.Node;

import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Marshaller;
import javax.xml.bind.annotation.*;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import java.util.ArrayList;
import java.util.List;

// End of user code


/**
 * Description of the class POCDMT000040Patient.
 *
 */

@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "POCD_MT000040.Patient", propOrder = {
	"realmCode",
	"typeId",
	"templateId",
	"id",
	"name",
	"administrativeGenderCode",
	"birthTime",
	"maritalStatusCode",
	"religiousAffiliationCode",
	"raceCode",
	"ethnicGroupCode",
	"guardian",
	"birthplace",
	"languageCommunication",
	"classCode",
	"determinerCode",
	"nullFlavor"
})
@XmlRootElement(name = "POCD_MT000040.Patient")
public class POCDMT000040Patient implements java.io.Serializable {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	
	@XmlElement(name = "realmCode", namespace = "urn:hl7-org:v3")
	public List<net.ihe.gazelle.datatypes.CS> realmCode;
	@XmlElement(name = "typeId", namespace = "urn:hl7-org:v3")
	public net.ihe.gazelle.cdaepsos3.POCDMT000040InfrastructureRootTypeId typeId;
	@XmlElement(name = "templateId", namespace = "urn:hl7-org:v3")
	public List<net.ihe.gazelle.datatypes.II> templateId;
	@XmlElement(name = "id", namespace = "urn:hl7-org:v3")
	public net.ihe.gazelle.datatypes.II id;
	@XmlElement(name = "name", namespace = "urn:hl7-org:v3")
	public List<net.ihe.gazelle.datatypes.PN> name;
	@XmlElement(name = "administrativeGenderCode", namespace = "urn:hl7-org:v3")
	public net.ihe.gazelle.datatypes.CE administrativeGenderCode;
	@XmlElement(name = "birthTime", namespace = "urn:hl7-org:v3")
	public net.ihe.gazelle.datatypes.TS birthTime;
	@XmlElement(name = "maritalStatusCode", namespace = "urn:hl7-org:v3")
	public net.ihe.gazelle.datatypes.CE maritalStatusCode;
	@XmlElement(name = "religiousAffiliationCode", namespace = "urn:hl7-org:v3")
	public net.ihe.gazelle.datatypes.CE religiousAffiliationCode;
	@XmlElement(name = "raceCode", namespace = "urn:hl7-org:v3")
	public net.ihe.gazelle.datatypes.CE raceCode;
	@XmlElement(name = "ethnicGroupCode", namespace = "urn:hl7-org:v3")
	public net.ihe.gazelle.datatypes.CE ethnicGroupCode;
	@XmlElement(name = "guardian", namespace = "urn:hl7-org:v3")
	public List<net.ihe.gazelle.cdaepsos3.POCDMT000040Guardian> guardian;
	@XmlElement(name = "birthplace", namespace = "urn:hl7-org:v3")
	public net.ihe.gazelle.cdaepsos3.POCDMT000040Birthplace birthplace;
	@XmlElement(name = "languageCommunication", namespace = "urn:hl7-org:v3")
	public List<net.ihe.gazelle.cdaepsos3.POCDMT000040LanguageCommunication> languageCommunication;
	@XmlAttribute(name = "classCode")
	public net.ihe.gazelle.voc.EntityClass classCode;
	@XmlAttribute(name = "determinerCode")
	public net.ihe.gazelle.voc.EntityDeterminer determinerCode;
	@XmlAttribute(name = "nullFlavor")
	public net.ihe.gazelle.voc.NullFlavor nullFlavor;
	
	/**
	 * An attribute containing marshalled element node
	 */
	@XmlTransient
	private org.w3c.dom.Node _xmlNodePresentation;
	
	
	/**
	 * Return realmCode.
	 * @return realmCode
	 */
	public List<net.ihe.gazelle.datatypes.CS> getRealmCode() {
		if (realmCode == null) {
	        realmCode = new ArrayList<net.ihe.gazelle.datatypes.CS>();
	    }
	    return realmCode;
	}
	
	/**
	 * Set a value to attribute realmCode.
	 * @param realmCode.
	 */
	public void setRealmCode(List<net.ihe.gazelle.datatypes.CS> realmCode) {
	    this.realmCode = realmCode;
	}
	
	
	
	/**
	 * Add a realmCode to the realmCode collection.
	 * @param realmCode_elt Element to add.
	 */
	public void addRealmCode(net.ihe.gazelle.datatypes.CS realmCode_elt) {
	    this.getRealmCode().add(realmCode_elt);
	}
	
	/**
	 * Remove a realmCode to the realmCode collection.
	 * @param realmCode_elt Element to remove
	 */
	public void removeRealmCode(net.ihe.gazelle.datatypes.CS realmCode_elt) {
	    this.getRealmCode().remove(realmCode_elt);
	}
	
	/**
	 * Return typeId.
	 * @return typeId
	 */
	public net.ihe.gazelle.cdaepsos3.POCDMT000040InfrastructureRootTypeId getTypeId() {
	    return typeId;
	}
	
	/**
	 * Set a value to attribute typeId.
	 * @param typeId.
	 */
	public void setTypeId(net.ihe.gazelle.cdaepsos3.POCDMT000040InfrastructureRootTypeId typeId) {
	    this.typeId = typeId;
	}
	
	
	
	
	/**
	 * Return templateId.
	 * @return templateId
	 */
	public List<net.ihe.gazelle.datatypes.II> getTemplateId() {
		if (templateId == null) {
	        templateId = new ArrayList<net.ihe.gazelle.datatypes.II>();
	    }
	    return templateId;
	}
	
	/**
	 * Set a value to attribute templateId.
	 * @param templateId.
	 */
	public void setTemplateId(List<net.ihe.gazelle.datatypes.II> templateId) {
	    this.templateId = templateId;
	}
	
	
	
	/**
	 * Add a templateId to the templateId collection.
	 * @param templateId_elt Element to add.
	 */
	public void addTemplateId(net.ihe.gazelle.datatypes.II templateId_elt) {
	    this.getTemplateId().add(templateId_elt);
	}
	
	/**
	 * Remove a templateId to the templateId collection.
	 * @param templateId_elt Element to remove
	 */
	public void removeTemplateId(net.ihe.gazelle.datatypes.II templateId_elt) {
	    this.getTemplateId().remove(templateId_elt);
	}
	
	/**
	 * Return id.
	 * @return id
	 */
	public net.ihe.gazelle.datatypes.II getId() {
	    return id;
	}
	
	/**
	 * Set a value to attribute id.
	 * @param id.
	 */
	public void setId(net.ihe.gazelle.datatypes.II id) {
	    this.id = id;
	}
	
	
	
	
	/**
	 * Return name.
	 * @return name
	 */
	public List<net.ihe.gazelle.datatypes.PN> getName() {
		if (name == null) {
	        name = new ArrayList<net.ihe.gazelle.datatypes.PN>();
	    }
	    return name;
	}
	
	/**
	 * Set a value to attribute name.
	 * @param name.
	 */
	public void setName(List<net.ihe.gazelle.datatypes.PN> name) {
	    this.name = name;
	}
	
	
	
	/**
	 * Add a name to the name collection.
	 * @param name_elt Element to add.
	 */
	public void addName(net.ihe.gazelle.datatypes.PN name_elt) {
	    this.getName().add(name_elt);
	}
	
	/**
	 * Remove a name to the name collection.
	 * @param name_elt Element to remove
	 */
	public void removeName(net.ihe.gazelle.datatypes.PN name_elt) {
	    this.getName().remove(name_elt);
	}
	
	/**
	 * Return administrativeGenderCode.
	 * @return administrativeGenderCode
	 */
	public net.ihe.gazelle.datatypes.CE getAdministrativeGenderCode() {
	    return administrativeGenderCode;
	}
	
	/**
	 * Set a value to attribute administrativeGenderCode.
	 * @param administrativeGenderCode.
	 */
	public void setAdministrativeGenderCode(net.ihe.gazelle.datatypes.CE administrativeGenderCode) {
	    this.administrativeGenderCode = administrativeGenderCode;
	}
	
	
	
	
	/**
	 * Return birthTime.
	 * @return birthTime
	 */
	public net.ihe.gazelle.datatypes.TS getBirthTime() {
	    return birthTime;
	}
	
	/**
	 * Set a value to attribute birthTime.
	 * @param birthTime.
	 */
	public void setBirthTime(net.ihe.gazelle.datatypes.TS birthTime) {
	    this.birthTime = birthTime;
	}
	
	
	
	
	/**
	 * Return maritalStatusCode.
	 * @return maritalStatusCode
	 */
	public net.ihe.gazelle.datatypes.CE getMaritalStatusCode() {
	    return maritalStatusCode;
	}
	
	/**
	 * Set a value to attribute maritalStatusCode.
	 * @param maritalStatusCode.
	 */
	public void setMaritalStatusCode(net.ihe.gazelle.datatypes.CE maritalStatusCode) {
	    this.maritalStatusCode = maritalStatusCode;
	}
	
	
	
	
	/**
	 * Return religiousAffiliationCode.
	 * @return religiousAffiliationCode
	 */
	public net.ihe.gazelle.datatypes.CE getReligiousAffiliationCode() {
	    return religiousAffiliationCode;
	}
	
	/**
	 * Set a value to attribute religiousAffiliationCode.
	 * @param religiousAffiliationCode.
	 */
	public void setReligiousAffiliationCode(net.ihe.gazelle.datatypes.CE religiousAffiliationCode) {
	    this.religiousAffiliationCode = religiousAffiliationCode;
	}
	
	
	
	
	/**
	 * Return raceCode.
	 * @return raceCode
	 */
	public net.ihe.gazelle.datatypes.CE getRaceCode() {
	    return raceCode;
	}
	
	/**
	 * Set a value to attribute raceCode.
	 * @param raceCode.
	 */
	public void setRaceCode(net.ihe.gazelle.datatypes.CE raceCode) {
	    this.raceCode = raceCode;
	}
	
	
	
	
	/**
	 * Return ethnicGroupCode.
	 * @return ethnicGroupCode
	 */
	public net.ihe.gazelle.datatypes.CE getEthnicGroupCode() {
	    return ethnicGroupCode;
	}
	
	/**
	 * Set a value to attribute ethnicGroupCode.
	 * @param ethnicGroupCode.
	 */
	public void setEthnicGroupCode(net.ihe.gazelle.datatypes.CE ethnicGroupCode) {
	    this.ethnicGroupCode = ethnicGroupCode;
	}
	
	
	
	
	/**
	 * Return guardian.
	 * @return guardian
	 */
	public List<net.ihe.gazelle.cdaepsos3.POCDMT000040Guardian> getGuardian() {
		if (guardian == null) {
	        guardian = new ArrayList<net.ihe.gazelle.cdaepsos3.POCDMT000040Guardian>();
	    }
	    return guardian;
	}
	
	/**
	 * Set a value to attribute guardian.
	 * @param guardian.
	 */
	public void setGuardian(List<net.ihe.gazelle.cdaepsos3.POCDMT000040Guardian> guardian) {
	    this.guardian = guardian;
	}
	
	
	
	/**
	 * Add a guardian to the guardian collection.
	 * @param guardian_elt Element to add.
	 */
	public void addGuardian(net.ihe.gazelle.cdaepsos3.POCDMT000040Guardian guardian_elt) {
	    this.getGuardian().add(guardian_elt);
	}
	
	/**
	 * Remove a guardian to the guardian collection.
	 * @param guardian_elt Element to remove
	 */
	public void removeGuardian(net.ihe.gazelle.cdaepsos3.POCDMT000040Guardian guardian_elt) {
	    this.getGuardian().remove(guardian_elt);
	}
	
	/**
	 * Return birthplace.
	 * @return birthplace
	 */
	public net.ihe.gazelle.cdaepsos3.POCDMT000040Birthplace getBirthplace() {
	    return birthplace;
	}
	
	/**
	 * Set a value to attribute birthplace.
	 * @param birthplace.
	 */
	public void setBirthplace(net.ihe.gazelle.cdaepsos3.POCDMT000040Birthplace birthplace) {
	    this.birthplace = birthplace;
	}
	
	
	
	
	/**
	 * Return languageCommunication.
	 * @return languageCommunication
	 */
	public List<net.ihe.gazelle.cdaepsos3.POCDMT000040LanguageCommunication> getLanguageCommunication() {
		if (languageCommunication == null) {
	        languageCommunication = new ArrayList<net.ihe.gazelle.cdaepsos3.POCDMT000040LanguageCommunication>();
	    }
	    return languageCommunication;
	}
	
	/**
	 * Set a value to attribute languageCommunication.
	 * @param languageCommunication.
	 */
	public void setLanguageCommunication(List<net.ihe.gazelle.cdaepsos3.POCDMT000040LanguageCommunication> languageCommunication) {
	    this.languageCommunication = languageCommunication;
	}
	
	
	
	/**
	 * Add a languageCommunication to the languageCommunication collection.
	 * @param languageCommunication_elt Element to add.
	 */
	public void addLanguageCommunication(net.ihe.gazelle.cdaepsos3.POCDMT000040LanguageCommunication languageCommunication_elt) {
	    this.getLanguageCommunication().add(languageCommunication_elt);
	}
	
	/**
	 * Remove a languageCommunication to the languageCommunication collection.
	 * @param languageCommunication_elt Element to remove
	 */
	public void removeLanguageCommunication(net.ihe.gazelle.cdaepsos3.POCDMT000040LanguageCommunication languageCommunication_elt) {
	    this.getLanguageCommunication().remove(languageCommunication_elt);
	}
	
	/**
	 * Return classCode.
	 * @return classCode
	 */
	public net.ihe.gazelle.voc.EntityClass getClassCode() {
	    return classCode;
	}
	
	/**
	 * Set a value to attribute classCode.
	 * @param classCode.
	 */
	public void setClassCode(net.ihe.gazelle.voc.EntityClass classCode) {
	    this.classCode = classCode;
	}
	
	
	
	
	/**
	 * Return determinerCode.
	 * @return determinerCode
	 */
	public net.ihe.gazelle.voc.EntityDeterminer getDeterminerCode() {
	    return determinerCode;
	}
	
	/**
	 * Set a value to attribute determinerCode.
	 * @param determinerCode.
	 */
	public void setDeterminerCode(net.ihe.gazelle.voc.EntityDeterminer determinerCode) {
	    this.determinerCode = determinerCode;
	}
	
	
	
	
	/**
	 * Return nullFlavor.
	 * @return nullFlavor
	 */
	public net.ihe.gazelle.voc.NullFlavor getNullFlavor() {
	    return nullFlavor;
	}
	
	/**
	 * Set a value to attribute nullFlavor.
	 * @param nullFlavor.
	 */
	public void setNullFlavor(net.ihe.gazelle.voc.NullFlavor nullFlavor) {
	    this.nullFlavor = nullFlavor;
	}
	
	
	
	
	
	public Node get_xmlNodePresentation() {
		if (_xmlNodePresentation == null){
				JAXBContext jc;
				DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
				dbf.setNamespaceAware(true);
				DocumentBuilder db = null;
				Document doc = null;
				try {
					db = dbf.newDocumentBuilder();
					doc = db.newDocument();
				} catch (ParserConfigurationException e1) {}
				try {
					jc = JAXBContext.newInstance("net.ihe.gazelle.cdaepsos3");
					Marshaller m = jc.createMarshaller();
					m.marshal(this, doc);
					_xmlNodePresentation = doc.getElementsByTagNameNS("urn:hl7-org:v3", "POCD_MT000040.Patient").item(0);
				} catch (JAXBException e) {
					try{
						db = dbf.newDocumentBuilder();
						_xmlNodePresentation = db.newDocument();
					}
					catch(Exception ee){}
				}
			}
			return _xmlNodePresentation;
	}
	
	public void set_xmlNodePresentation(Node _xmlNodePresentation) {
		this._xmlNodePresentation = _xmlNodePresentation;
	}
	
	
	

	
	/**
     * validate by a module of validation
     * 
     */
   public static void validateByModule(POCDMT000040Patient pOCDMT000040Patient, String _location, ConstraintValidatorModule cvm, List<net.ihe.gazelle.validation.Notification> diagnostic){
   		if (pOCDMT000040Patient != null){
   			cvm.validate(pOCDMT000040Patient, _location, diagnostic);
			{
				int i = 0;
				for (net.ihe.gazelle.datatypes.CS realmCode: pOCDMT000040Patient.getRealmCode()){
					net.ihe.gazelle.datatypes.CS.validateByModule(realmCode, _location + "/realmCode[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			net.ihe.gazelle.cdaepsos3.POCDMT000040InfrastructureRootTypeId.validateByModule(pOCDMT000040Patient.getTypeId(), _location + "/typeId", cvm, diagnostic);
			{
				int i = 0;
				for (net.ihe.gazelle.datatypes.II templateId: pOCDMT000040Patient.getTemplateId()){
					net.ihe.gazelle.datatypes.II.validateByModule(templateId, _location + "/templateId[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			net.ihe.gazelle.datatypes.II.validateByModule(pOCDMT000040Patient.getId(), _location + "/id", cvm, diagnostic);
			{
				int i = 0;
				for (net.ihe.gazelle.datatypes.PN name: pOCDMT000040Patient.getName()){
					net.ihe.gazelle.datatypes.PN.validateByModule(name, _location + "/name[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			net.ihe.gazelle.datatypes.CE.validateByModule(pOCDMT000040Patient.getAdministrativeGenderCode(), _location + "/administrativeGenderCode", cvm, diagnostic);
			net.ihe.gazelle.datatypes.TS.validateByModule(pOCDMT000040Patient.getBirthTime(), _location + "/birthTime", cvm, diagnostic);
			net.ihe.gazelle.datatypes.CE.validateByModule(pOCDMT000040Patient.getMaritalStatusCode(), _location + "/maritalStatusCode", cvm, diagnostic);
			net.ihe.gazelle.datatypes.CE.validateByModule(pOCDMT000040Patient.getReligiousAffiliationCode(), _location + "/religiousAffiliationCode", cvm, diagnostic);
			net.ihe.gazelle.datatypes.CE.validateByModule(pOCDMT000040Patient.getRaceCode(), _location + "/raceCode", cvm, diagnostic);
			net.ihe.gazelle.datatypes.CE.validateByModule(pOCDMT000040Patient.getEthnicGroupCode(), _location + "/ethnicGroupCode", cvm, diagnostic);
			{
				int i = 0;
				for (net.ihe.gazelle.cdaepsos3.POCDMT000040Guardian guardian: pOCDMT000040Patient.getGuardian()){
					net.ihe.gazelle.cdaepsos3.POCDMT000040Guardian.validateByModule(guardian, _location + "/guardian[" + i + "]", cvm, diagnostic);
					i++;
				}
			}

			net.ihe.gazelle.cdaepsos3.POCDMT000040Birthplace.validateByModule(pOCDMT000040Patient.getBirthplace(), _location + "/birthplace", cvm, diagnostic);
			{
				int i = 0;
				for (net.ihe.gazelle.cdaepsos3.POCDMT000040LanguageCommunication languageCommunication: pOCDMT000040Patient.getLanguageCommunication()){
					net.ihe.gazelle.cdaepsos3.POCDMT000040LanguageCommunication.validateByModule(languageCommunication, _location + "/languageCommunication[" + i + "]", cvm, diagnostic);
					i++;
				}
			}

    	}
    }

}